#ifndef s_H_CONDITION
#define s_H_CONDITION
#include <allegro5/allegro.h>

class Condition {
   public:
      const unsigned int event_type;

      virtual bool is_true(ALLEGRO_EVENT*) = 0;
      virtual Condition* alias() = 0;
      virtual void unalias()
      {
         delete this;
      }
      virtual void reset(){
         return;
      }
      Condition(unsigned int type)
         : event_type(type)
      {}
      virtual ~Condition()
      {}
};

class RefCountCondition: public Condition {
   private:
      unsigned int ref_count;
   public:
      virtual Condition* alias(){
         ref_count++;
         return this;
      }
      virtual void unalias()
      {
         if(!--ref_count)
            delete this;
      }
      RefCountCondition(unsigned int i)
         : Condition(i), ref_count(1)
      {}
};
#endif