#ifndef s_H_CONDITIONCASES
#define s_H_CONDITIONCASES
#include "condition.hpp"

class CertainButtonDown : public RefCountCondition {
   private:
      const int key;
   public:
      virtual bool is_true(ALLEGRO_EVENT* e) {
         return e->keyboard.keycode == key;
      }
      CertainButtonDown(int k)
         : RefCountCondition(ALLEGRO_EVENT_KEY_DOWN), key(k)
      {}
      //reset
};

class CertainButtonUp : public RefCountCondition {
   private:
      const int key;
   public:
      virtual bool is_true(ALLEGRO_EVENT* e) {
         return e->keyboard.keycode == key;
      }
      CertainButtonUp(int k)
         : RefCountCondition(ALLEGRO_EVENT_KEY_UP), key(k)
      {}
      //reset
};

class AnyTimerTicks : public Condition {
   private:
      const int ticks_to_wait;
      int ticks_passed;
   public:
      virtual bool is_true(ALLEGRO_EVENT*){
         //the caller already knows this only responds to timer events
         return (++ticks_passed == ticks_to_wait);
      }
      virtual Condition* alias() {
         return new AnyTimerTicks(ticks_to_wait);
      }
      void reset(){
         ticks_passed=0;
      }
      AnyTimerTicks(int ticks)
         :Condition(ALLEGRO_EVENT_TIMER), ticks_to_wait(ticks), ticks_passed(0)
      {}
};
#endif