#ifndef s_H_GLOBALS
#define s_H_GLOBALS
#include <allegro5/allegro5.h>
#include <string>

struct GlobalVars
{
   ALLEGRO_DISPLAY* display;
   ALLEGRO_TIMER* timer;
   ALLEGRO_EVENT event;
   ALLEGRO_EVENT_QUEUE *queue;
   enum State{
      Continue,
      Quit,
      Error
   }volatile gamestate;
   double gdt;//Time wanted between screen updates
   int max_gfs_allowed;//Maximum allowed graphics frames to skip rendering of
   float max_logic_time;
   //float lpgdt;//Wanted logic updates per time between screen updates
   //float max_logic_lag;//Amount of lag to drop timer events after
   GlobalVars()
      : gamestate(Continue), gdt(1.0/60.0), max_gfs_allowed(30), max_logic_time(gdt * max_gfs_allowed)
   {
      if (al_init()&&al_install_keyboard()&&al_install_mouse()&& al_init_primitives_addon()&& al_install_mouse()) {
         al_set_new_display_option(ALLEGRO_VSYNC, 1, ALLEGRO_SUGGEST);
         //al_set_new_display_option(ALLEGRO_SINGLE_BUFFER, 1, ALLEGRO_SUGGEST);
         al_set_new_display_option(ALLEGRO_AUX_BUFFERS, 1, ALLEGRO_SUGGEST);
         display = al_create_display(640, 480);
         queue = al_create_event_queue();
         timer = al_create_timer(2e-3);
         if (!(display&&queue&&timer)) {
            gamestate=Error;
         } else {
            al_register_event_source(queue, al_get_keyboard_event_source());
            al_register_event_source( queue, al_get_display_event_source(display) );
            al_register_event_source( queue, al_get_mouse_event_source() );
            al_register_event_source( queue, al_get_timer_event_source(timer) );
            //al_set_blender(ALLEGRO_ADD, ALLEGRO_ONE, ALLEGRO_ZERO);
            al_start_timer(timer);
         }
      } else {
         gamestate=Error;
      }
   }
   ~GlobalVars(){
      if(timer)
         al_destroy_timer(timer);
      if(queue)
         al_destroy_event_queue(queue);
      if(display)
         al_destroy_display(display);
   }
};
#endif